         @program prog_code,prog_name

buffer   equ      0
youx     equ      buffer+3504
youy     equ      youx+2
shield   equ      youy+2
lives    equ      shield
score    equ      lives+2
level    equ      score+2
shot     equ      level+2
nume     equ      shot+2
vbl      equ      nume+2
enemy    equ      vbl+2
bullets  equ      enemy+120
bullet   equ      bullets
ebuls    equ      bullet+384
tmp      equ      ebuls+384
f1       equ      tmp+16
f2       equ      f1+2
f3       equ      f2+2
high     equ      f3+2
low      equ      high+2
oldsp    equ      low+2
lvldata  equ      oldsp+4
ttlsize  equ      lvldata+480
MEM      equ      (ttlsize+3) and $FFFFFFFC

LEVELS   equ      4

boff_s   equ      0
boff_x   equ      2
boff_y   equ      4
boff_w   equ      6
boff_h   equ      8
boff_c   equ      10
boff_d   equ      12
boff_m   equ      14

eoff_s   equ      0
eoff_x   equ      2
eoff_y   equ      4
eoff_w   equ      6
eoff_h   equ      8
eoff_c   equ      10
eoff_d   equ      12
eoff_xv  equ      14
eoff_yv  equ      16
eoff_i   equ      18

eboff_s  equ      0
eboff_x  equ      2
eboff_y  equ      4
eboff_w  equ      6
eboff_h  equ      8
eboff_d  equ      10
eboff_xv equ      12
eboff_yv equ      14

prog_code:
         moveq    #48,d0
         move.l   #MEM,d1
         lea      program(pc),a0
         move.w   #$e1,$600016
         jsr      skittles[check_version]
         move.w   #$b2,$600016
         rts

program: lea      (a1),a6
         move.w   #(MEM/4)-1,d0
lc:      clr.l    (a1)+
         dbra     d0,lc
         move.l   sp,oldsp(a6)
         move.l   a6,-(sp)
         lea      enemy_data_bank(pc),a1
         lea      lvldata(a6),a0
         jsr      skittles[stc_decrunch]
         move.l   (sp)+,a6

         jsr      skittles[cllcd]

         move.w   #180,d0
         moveq    #1,d1
         lea      name(pc),a1
         jsr      skittles[text]
         move.w   #180,d0
         moveq    #36,d1
         lea      cont(pc),a1
         jsr      skittles[text]
         move.w   #186,d0
         moveq    #86,d1
         lea      stat(pc),a1
         jsr      skittles[text]

         moveq    #10,d7
         lea      auths(pc),a5
ldtt:    moveq    #0,d0
         moveq    #0,d1
         move.b   (a5)+,d0
         move.b   (a5)+,d1
         lea      (a5),a1
         jsr      skittles[tinytext]
lfe:     tst.b    (a5)+
         bne.s    lfe
         dbra     d7,ldtt

         lea      LCD_MEM+20,a0
         moveq    #119,d1
lline:   bset     #7,(a0)
         lea      30(a0),a0
         dbra     d1,lline
         moveq    #-1,d1
         lea      LCD_MEM+3600,a0
         moveq    #14,d0
ilineh:  move.w   d1,(a0)+
         dbra     d0,ilineh

         move.w   #90,youx(a6)
         move.w   #120,youy(a6)
         move.w   #20,shield(a6)
         move.w   #63,high(a6)
         move.w   #31,low(a6)

main_loop:
         move.w   vbl(a6),d0
         addq.w   #1,d0
         and.w    #63,d0
         bne.s    ns
         addq.w   #1,score(a6)
ns:      move.w   d0,vbl(a6)
         bsr      clrtemp
         bsr      do_game
         bsr      wait_vbl
         bsr      cpytemp
         bsr      info
         tst.w    shield(a6)
         ble.s    gameo
         cmp.w    #4,level(a6)
         ble.s    nohp
         move.w   #31,high(a6)
         move.w   #15,low(a6)
nohp:    cmp.w    #32,level(a6)
         beq.s    gamew
         move.w   #%1111111101111111,$600018
         nop
         nop
         btst     #6,$60001b
         beq.s    paused
upawz    move.w   #%1111111011111111,$600018
         nop
         nop
         btst     #6,$60001b
         bne.s    main_loop
         move.l   oldsp(a6),sp
         rts
gameo:   moveq    #30,d0
         moveq    #90,d1
         lea      game_over(pc),a1
         jsr      skittles[text]
         jsr      skittles[wait_esc]
         moveq    #0,d7
         move.w   score(a6),d7
         lea      hstable,a5
         jmp      skittles[high_score]
gamew:   add.w    #$1000,score(a6)
         bsr      info
         moveq    #60,d0
         moveq    #80,d1
         lea      game_win(pc),a1
         jsr      skittles[text]
         bra.s    gameo
paused:  lea      game_paused(pc),a1
         moveq    #80,d1
         moveq    #30,d0
         jsr      skittles[text]
wnp1:    btst     #6,$60001b
         beq.s    wnp1
wp:      btst     #6,$60001b
         bne.s    wp
wnp2:    btst     #6,$60001b
         bne      upawz
         bra.s    wnp2

info:    move.w   shield(a6),d0
         moveq    #26,d2
         moveq    #12,d1
         moveq    #3,d4
         jsr      hexlib[put_hex]
         move.w   score(a6),d0
         moveq    #26,d2
         moveq    #13,d1
         moveq    #3,d4
         jsr      hexlib[put_hex]
         move.w   level(a6),d0
         moveq    #26,d2
         moveq    #14,d1
         moveq    #3,d4
         jmp      hexlib[put_hex]

wait_vbl:
         tst.b    $600017
         bne.s    wait_vbl
         rts
clrtemp: lea      504+2(a6),a0
         moveq    #118,d1
         moveq    #0,d0
ctl:     move.l   d0,(a0)+
         move.l   d0,(a0)+
         move.l   d0,(a0)+
         move.l   d0,(a0)+
         move.l   d0,(a0)+
         addq.l   #4,a0
         dbra     d1,ctl
         rts

cpytemp: lea      504+2(a6),a0
         lea      LCD_MEM+30,a1
         moveq    #118,d1
         moveq    #10,d0
cpl:     move.l   (a0)+,(a1)+
         move.l   (a0)+,(a1)+
         move.l   (a0)+,(a1)+
         move.l   (a0)+,(a1)+
         move.l   (a0)+,(a1)+
         addq.l   #4,a0
         add.l    d0,a1
         dbra     d1,cpl
         rts

do_f1:   lea      tmp(a6),a1
         move.w   youx(a6),boff_x(a1)
         move.w   youy(a6),boff_y(a1)
         move.w   #2,(a1)
         subq.w   #8,boff_y(a1)
         addq.w   #4,boff_x(a1)
         move.w   #3,boff_w(a1)
         move.w   #11,boff_h(a1)
         move.w   #3,boff_d(a1)
         lea      bullets(a6),a2
         bra      put_struct
do_f2:   lea      tmp(a6),a1
         move.w   youx(a6),boff_x(a1)
         move.w   youy(a6),boff_y(a1)
         move.w   #4,(a1)
         subq.w   #8,boff_y(a1)
         move.w   #4,boff_w(a1)
         move.w   #11,boff_h(a1)
         move.w   #2,boff_d(a1)
         clr.w    boff_c(a1)
         lea      bullets(a6),a2
         move.w   #-1,boff_m(a1)
         bsr      put_struct
         lea      tmp(a6),a1
         lea      bullets(a6),a2
         addq.w   #8,boff_x(a1)
         move.w   #1,boff_m(a1)
         bra      put_struct
do_f3:   lea      tmp(a6),a1
         move.w   youx(a6),boff_x(a1)
         move.w   youy(a6),boff_y(a1)
         subq.w   #4,boff_y(a1)
         addq.w   #3,boff_x(a1)
         move.w   #5,boff_w(a1)
         move.w   #5,boff_h(a1)
         move.w   #2,boff_d(a1)
         clr.w    boff_c(a1)
         lea      bullets(a6),a2
         lea      tmp(a6),a1
         move.w   #6,(a1)
         bsr      put_struct
         lea      bullets(a6),a2
         lea      tmp(a6),a1
         move.w   #8,(a1)
         bsr      put_struct
         lea      bullets(a6),a2
         lea      tmp(a6),a1
         move.w   #10,(a1)
         addq.w   #1,boff_x(a1)
         bsr      put_struct
         lea      bullets(a6),a2
         lea      tmp(a6),a1
         move.w   #12,(a1)
         bra      put_struct

put_struct:
         moveq    #23,d7
loop_ps: tst.w    (a2)
         beq.s    found_place
         lea      16(a2),a2
         dbra     d7,loop_ps
         rts
found_place:
         move.l   (a1)+,(a2)+
         move.l   (a1)+,(a2)+
         move.l   (a1)+,(a2)+
         move.l   (a1)+,(a2)+
         rts

do_game: lea      ebuls(a6),a2
         moveq    #23,d7
ebloop:  tst.w    (a2)
         beq      notnow
         move.w   eboff_xv(a2),d0
         move.w   d0,d1
         asr.w    #1,d0
         add.w    eboff_x(a2),d0
         btst     #0,vbl+1(a6)
         bne.s    nohalf
         btst     #0,d1
         beq.s    nohalf
         addq.w   #1,d0
         tst.w    d0
         bgt.s    nohalf
         subq.w   #2,d0
nohalf:  blt.s    ebulgone
         cmp.w    #180,d0
         bgt.s    ebulgone
         move.w   d0,eboff_x(a2)
         move.w   eboff_y(A2),d1
         add.w    eboff_yv(a2),d1
         cmp.w    #140,d1
         bgt.s    ebulgone
         move.w   d1,eboff_y(a2)
         move.w   d0,d2
         sub.w    youx(a6),d2
         add.w    eboff_w(a2),d2
         ble.s    nohit
         sub.w    eboff_w(a2),d2
         sub.w    #12,d2
         bge.s    nohit
         move.w   d1,d2
         sub.w    youy(a6),d2
         add.w    eboff_h(a2),d2
         ble.s    nohit
         sub.w    eboff_h(a2),d2
         sub.w    #9,d2
         bge.s    nohit
         move.w   eboff_d(a2),d5
         sub.w    d5,lives(a6)
ebulgone clr.w    (a2)
         bra.s    notnow
nohit:   lea      sprite_pulse(pc),a0
         lea      (a6),a1
         jsr      skittles[put_sprite24]
notnow:  lea      16(a2),a2
         dbra     d7,ebloop

         move.w   #%1111111111111110,$600018
         move.w   youx(a6),d0
         move.w   youy(a6),d1
         moveq    #1,d5
         move.w   $60001a,d6
         btst     #3,d6
         bne.s    nofast
         moveq    #2,d5
nofast:  btst     #7,d6
         bne.s    nodown
         add.w    d5,d1
         cmp.w    #131,d1
         ble.s    nodown
         move.w   #131,d1
nodown:  btst     #4,d6
         bne.s    noright
         sub.w    d5,d0
         cmp.w    #16,d0
         bge.s    noright
         move.w   #16,d0
noright: btst     #5,d6
         bne.s    noup
         sub.w    d5,d1
         cmp.w    #112,d1
         bge.s    noup
         move.w   #112,d1
noup:    btst     #6,d6
         bne.s    noleft
         add.w    d5,d0
         cmp.w    #165,d0
         ble.s    noleft
         move.w   #165,d0
noleft:  move.w   d0,youx(a6)
         move.w   d1,youy(a6)
         lea      (a6),a1
         lea      sprite_your_ship(pc),a0
         jsr      skittles[put_sprite24]

         move.w   #%1111111110111111,$600018
         nop
         nop
         btst     #4,$60001b
         bne.s    no_f1
         tst.w    f1(a6)
         bne.s    f1_failed
         st       f1(a6)
         bsr      do_f1
         bra.s    f1_failed
no_f1:   clr.w    f1(a6)
f1_failed:
         move.w   #%1111111111101111,$600018
         moveq    #5,d5
pawz:    nop
         dbra     d5,pawz
         btst     #4,$60001b
         bne.s    no_f2
         tst.w    f2(a6)
         bne.s    f2_failed
         st       f2(a6)
         bsr      do_f2
         bra.s    f2_failed
no_f2:   clr.w    f2(a6)
f2_failed:
         move.w   #%1111111111111011,$600018
         nop
         nop
         nop
         btst     #4,$60001b
         bne.s    no_f3
         tst.w    f3(a6)
         bne.s    f3_failed
         st       f3(a6)
         bsr      do_f3
         bra.s    f3_failed
no_f3:   clr.w    f3(a6)
f3_failed:
         moveq    #23,d7
         lea      bullet_code(pc),a3
         lea      bullets(a6),a2
do_blp:  move.w   (a2),d0
         beq.s    nbh
         move.w   0(a3,d0.w),d0
         jsr      0(a3,d0.w)
nbh:     lea      16(a2),a2
         dbra     d7,do_blp

         lea      enemy_pix(pc),a4
         lea      enemy_code_bank(pc),a3
         lea      enemy(a6),a2
         moveq    #5,d7
do_elp:  move.w   (a2),d0
         blt      ebu
         beq      neh
         lea      bullets(a6),a0
         moveq    #23,d1
bulhittest:
         tst.w    (a0)
         beq.s    \endb
         move.w   eoff_x(a2),d4
         add.w    eoff_w(a2),d4
         sub.w    boff_x(a0),d4
         ble.s    \endb
         sub.w    eoff_w(a2),d4
         sub.w    boff_w(a0),d4
         bge.s    \endb
         move.w   eoff_y(a2),d4
         add.w    eoff_h(a2),d4
         sub.w    boff_y(a0),d4
         ble.s    \endb
         sub.w    eoff_h(a2),d4
         sub.w    boff_h(a0),d4
         bge.s    \endb
         move.w   boff_d(a0),d4
         clr.w    (a0)
         addq.w   #8,score(a6)
         move.w   eoff_d(a2),d3
         sub.w    d4,d3
         move.w   d3,eoff_d(a2)
         add.w    level(a6),d3
         bgt.s    \endb
         move.w   #-14,(a2)
         cmp.w    #8,eoff_i(a2)
         bne.s    \nb
         addq.w   #2,eoff_x(a2)
\nb:     add.w    #$40,score(a6)
         move.w   #10,eoff_i(a2)
         bra.s    neh
\endb:   lea      16(a0),a0
         dbra     d1,bulhittest
         addq.w   #1,eoff_c(a2)
         move.w   0(a3,d0.w),d0
         jsr      0(a3,d0.w)
         move.w   eoff_x(a2),d0
         add.w    eoff_xv(A2),d0
         move.w   d0,eoff_x(a2)
         move.w   eoff_y(a2),d1
         add.w    eoff_yv(a2),d1
         move.w   d1,eoff_y(a2)
         move.w   eoff_i(a2),d2
         move.w   0(a4,d2.w),d2
         lea      0(a4,d2.w),a0
         lea      (a6),a1
         jsr      skittles[put_sprite24]
neh:     lea      20(a2),a2
         dbra     d7,do_elp

         tst.w    nume(a6)
         bne.s    no_new_level
         move.w   vbl(a6),0
         and.w    #31,d0
         bne.s    no_new_level
         lea      lvldata(a6),a0
         move.w   level(a6),d0
         and.w    #LEVELS-1,d0
         mulu     #120,d0
         lea      0(a0,d0.w),a0
         moveq    #29,d0
         lea      enemy(a6),a1
lce:     move.l   (a0)+,(a1)+
         dbra     d0,lce
         addq.w   #1,level(a6)
         addq.w   #1,shield(a6)
         add.w    #$400,score(a6)
         move.w   #6,nume(a6)
no_new_level:
         rts

bullet_code:
         dc.w     bdie-bullet_code
         dc.w     bphaser-bullet_code
         dc.w     bdisr-bullet_code
         dc.w     bmp1-bullet_code
         dc.w     bmp2-bullet_code
         dc.w     bmp3-bullet_code
         dc.w     bmp4-bullet_code
bmp2:    move.w   boff_y(a2),d1
         subq.w   #2,d1
         blt.s    bdie
         move.w   boff_x(a2),d0
         subq.w   #2,d0
         blt.s    bdie
         move.w   d1,boff_y(a2)
         move.w   d0,boff_x(a2)
         lea      sprite_pulse(pc),a0
         lea      (a6),a1
         jmp      skittles[put_sprite24]
bmp3:    move.w   boff_y(a2),d1
         subq.w   #2,d1
         blt.s    bdie
         move.w   boff_x(a2),d0
         addq.w   #2,d0
         cmp.w    #180,d0
         bgt.s    bdie
         move.w   d1,boff_y(a2)
         move.w   d0,boff_x(a2)
         lea      sprite_pulse(pc),a0
         lea      (a6),a1
         jmp      skittles[put_sprite24]
bmp4:    move.w   boff_y(a2),d1
         subq.w   #4,d1
         blt.s    bdie
         move.w   boff_x(a2),d0
         addq.w   #1,d0
         cmp.w    #180,d0
         bgt.s    bdie
         move.w   d1,boff_y(a2)
         move.w   d0,boff_x(a2)
         lea      sprite_pulse(pc),a0
         lea      (a6),a1
         jmp      skittles[put_sprite24]
bdie:    clr.w    (a2)
         rts
bphaser: move.w   boff_y(a2),d1
         subq.w   #3,d1
         blt.s    bdie
         move.w   d1,boff_y(a2)
         move.w   boff_x(a2),d0
         lea      sprite_phaser_blast(pc),a0
         lea      (a6),a1
         jmp      skittles[put_sprite24]
bdisr:   move.w   boff_y(a2),d1
         subq.w   #3,d1
         blt.s    bdie
         move.w   d1,boff_y(a2)
         move.w   boff_x(a2),d0
         addq.w   #1,boff_c(a2)
         btst     #2,boff_c+1(a2)
         beq.s    nods
         add.w    boff_m(a2),d0
         move.w   d0,boff_x(a2)
nods:    lea      sprite_disruptor_bolt(PC),a0
         lea      (a6),a1
         jmp      skittles[put_sprite24]
bmp1:    move.w   boff_y(a2),d1
         subq.w   #4,d1
         blt.s    bdie
         move.w   boff_x(a2),d0
         subq.w   #1,d0
         blt.s    bdie
         move.w   d1,boff_y(a2)
         move.w   d0,boff_x(a2)
         lea      sprite_pulse(pc),a0
         lea      (a6),a1
         jmp      skittles[put_sprite24]

ebu:     addq.w   #1,d0
         move.w   d0,(a2)
         beq.s    eded
         btst     #0,d0
         bne.s    ntfic
         addq.w   #2,eoff_i(a2)
ntfic:   move.w   eoff_i(a2),d2
         move.w   0(a4,d2.w),d2
         lea      0(a4,d2.w),a0
         pea      neh(pc)
         lea      (a6),a1
         move.w   eoff_x(a2),d0
         move.w   eoff_y(a2),d1
         jmp      skittles[put_sprite24]
eded:    subq.w   #1,nume(a6)
         bra      neh


hstable: dc.b     "Patrick Andrew Davidson  ",0
         dc.l     $79bd
         dc.b     "Default score            ",0
         dc.l     $3400
         dc.b     "Default score            ",0
         dc.l     $3000
         dc.b     "Default score            ",0
         dc.l     $2c00
         dc.b     "Default score            ",0
         dc.l     $2800
         dc.b     "Default score            ",0
         dc.l     $2400
         dc.b     "Default score            ",0
         dc.l     $2000
         dc.b     "Default score            ",0
         dc.l     $1c00
         dc.b     "Default score            ",0
         dc.l     $1800
         dc.b     "Default score            ",0
         dc.l     $1400
         dc.b     "Default score            ",0
         dc.l     $1000
         dc.b     "Default score            ",0
         dc.l     $c00
         dc.b     "Default score            ",0
         dc.l     $800
         dc.b     "Default score            ",0
         dc.l     $400

sprite_your_ship:
         dc.w     8
         dc.l     %00000000010001100010000000000000
         dc.l     %00000000110011110011000000000000
         dc.l     %00000000110011110011000000000000
         dc.l     %00000000110011110011000000000000
         dc.l     %00000000110011110011000000000000
         dc.l     %00000000111111111111000000000000
         dc.l     %00000000111111111111000000000000
         dc.l     %00000000111100001111000000000000
         dc.l     %00000000110000000011000000000000

sprite_phaser_blast:
         dc.w     11
         dc.l     %00000000010100000000000000000000
         dc.l     %00000000101000000000000000000000
         dc.l     %00000000010100000000000000000000
         dc.l     %00000000101000000000000000000000
         dc.l     %00000000010100000000000000000000
         dc.l     %00000000101000000000000000000000
         dc.l     %00000000010100000000000000000000
         dc.l     %00000000101000000000000000000000
         dc.l     %00000000010100000000000000000000
         dc.l     %00000000101000000000000000000000
         dc.l     %00000000010100000000000000000000
         dc.l     %00000000101000000000000000000000
sprite_disruptor_bolt:
         dc.w     8
         dc.l     %00000000011000000000000000000000
         dc.l     %00000000111100000000000000000000
         dc.l     %00000000100100000000000000000000
         dc.l     %00000000100100000000000000000000
         dc.l     %00000000100100000000000000000000
         dc.l     %00000000100100000000000000000000
         dc.l     %00000000100100000000000000000000
         dc.l     %00000000100100000000000000000000
         dc.l     %00000000100100000000000000000000
sprite_pulse:
         dc.w     4
         dc.l     %00000000011100000000000000000000
         dc.l     %00000000111110000000000000000000
         dc.l     %00000000111110000000000000000000
         dc.l     %00000000111110000000000000000000
         dc.l     %00000000011100000000000000000000
enemy_pix:
         dc.w     sprite_enemy_1-enemy_pix
         dc.w     sprite_enemy_2-enemy_pix
         dc.w     sprite_enemy_3-enemy_pix
         dc.w     sprite_enemy_4-enemy_pix
         dc.w     sprite_boss-enemy_pix
         dc.w     sprite_expl_1-enemy_pix
         dc.w     sprite_expl_2-enemy_pix
         dc.w     sprite_expl_3-enemy_pix
         dc.w     sprite_expl_4-enemy_pix
         dc.w     sprite_expl_5-enemy_pix
         dc.w     sprite_expl_6-enemy_pix
         dc.w     sprite_expl_7-enemy_pix

sprite_enemy_1:
         dc.w     8           
         dc.l     %00000000100000000100000000000000
         dc.l     %00000000110000001100000000000000
         dc.l     %00000000111111111100000000000000
         dc.l     %00000000100000000100000000000000
         dc.l     %00000000100000000100000000000000
         dc.l     %00000000100000000100000000000000
         dc.l     %00000000110000001100000000000000
         dc.l     %00000000011000011000000000000000
         dc.l     %00000000001111110000000000000000
sprite_enemy_2:
         dc.w     7
         dc.l     %00000000110000110000000000000000
         dc.l     %00000000101001010000000000000000
         dc.l     %00000000100110010000000000000000
         dc.l     %00000000100000010000000000000000
         dc.l     %00000000100000010000000000000000
         dc.l     %00000000010000100000000000000000
         dc.l     %00000000001001000000000000000000
         dc.l     %00000000000110000000000000000000
sprite_enemy_3:
         dc.w     7
         dc.l     %00000000100000001000000000000000
         dc.l     %00000000100000001000000000000000
         dc.l     %00000000100000001000000000000000
         dc.l     %00000000111111111000000000000000
         dc.l     %00000000111111111000000000000000
         dc.l     %00000000011111110000000000000000
         dc.l     %00000000001111100000000000000000
         dc.l     %00000000000111000000000000000000
sprite_enemy_4:
         dc.w     8
         dc.l     %00000000111000000011100000000000
         dc.l     %00000000111110001111100000000000
         dc.l     %00000000100011111000100000000000
         dc.l     %00000000100000000000100000000000
         dc.l     %00000000101100000110100000000000
         dc.l     %00000000101010001010100000000000
         dc.l     %00000000101010001010100000000000
         dc.l     %00000000111011111011100000000000
         dc.l     %00000000010001110001000000000000
sprite_boss:
         dc.w     9
         dc.l     %00000000111110000000111110000000
         dc.l     %00000000100011111111100010000000
         dc.l     %00000000100000111110000010000000
         dc.l     %00000000100000001000000010000000
         dc.l     %00000000100000001000000010000000
         dc.l     %00000000110000001000000110000000
         dc.l     %00000000011000001000001100000000
         dc.l     %00000000001100001000011000000000
         dc.l     %00000000000110001000110000000000
         dc.l     %00000000000011111111100000000000
sprite_expl_1:
         dc.w     7
         dc.l     %00000000001001100000000000000000
         dc.l     %00000000110010001000000000000000
         dc.l     %00000000011010101100000000000000
         dc.l     %00000000111011110000000000000000
         dc.l     %00000000011001011100000000000000
         dc.l     %00000000011101010100000000000000
         dc.l     %00000000001111100000000000000000
         dc.l     %00000000000011001000000000000000
sprite_expl_2:
         dc.w     7
         dc.l     %00000000001001100000000000000000
         dc.l     %00000000110110001100000000000000
         dc.l     %00000000010010100100000000000000
         dc.l     %00000000100000101100000000000000
         dc.l     %00000000011000011010000000000000
         dc.l     %00000000010101010100000000000000
         dc.l     %00000000001101110000000000000000
         dc.l     %00000000000011001000000000000000
sprite_expl_3:
         dc.w     7
         dc.l     %00000000001001100000000000000000
         dc.l     %00000000100010001000000000000000
         dc.l     %00000000001010101110000000000000
         dc.l     %00000000100000000100000000000000
         dc.l     %00000000001000010010000000000000
         dc.l     %00000000010100001000000000000000
         dc.l     %00000000010100100100000000000000
         dc.l     %00000000100011001000000000000000
sprite_expl_4:
         dc.w     7
         dc.l     %00000000001001100000000000000000
         dc.l     %00000000100000001010000000000000
         dc.l     %00000000001000100100000000000000
         dc.l     %00000000100000000010000000000000
         dc.l     %00000000001000010100000000000000
         dc.l     %00000000010001001000000000000000
         dc.l     %00000000010000000010000000000000
         dc.l     %00000000000011001000000000000000
sprite_expl_5:
         dc.w     8 
         dc.l     %00000000001000100000000000000000
         dc.l     %00000000100010000100000000000000
         dc.l     %00000000000000001000000000000000
         dc.l     %00000000100000000010000000000000
         dc.l     %00000000001000010100000000000000
         dc.l     %00000000000000001000000000000000
         dc.l     %00000000010000000100000000000000
         dc.l     %00000000000001001010000000000000
         dc.l     %00000000000010010000000000000000
sprite_expl_6:
         dc.w     8 
         dc.l     %00000000001000100000000000000000
         dc.l     %00000000100001001000000000000000
         dc.l     %00000000000000000101000000000000
         dc.l     %00000000000000000000000000000000
         dc.l     %00000000101000000010000000000000
         dc.l     %00000000000000000000000000000000
         dc.l     %00000000010000000000000000000000
         dc.l     %00000000000000001010000000000000
         dc.l     %00000000000100010000000000000000
sprite_expl_7:
         dc.w     8 
         dc.l     %00000000001000100000000000000000
         dc.l     %00000000100000000010000000000000
         dc.l     %00000000000000000000000000000000
         dc.l     %00000000000000000000000000000000
         dc.l     %00000000000000000000000000000000
         dc.l     %00000000100000000000000000000000
         dc.l     %00000000000000000010000000000000
         dc.l     %00000000010000000100000000000000
         dc.l     %00000000000001010000000000000000

enemy_data_bank:
         INCBIN   galaxian.stc

enemy_code_bank:
         dc.w     enr-enemy_code_bank
         dc.w     en1-enemy_code_bank
         dc.w     en2-enemy_code_bank
         dc.w     enrand-enemy_code_bank
         dc.w     enboss-enemy_code_bank

en1:     cmp.w    #30,eoff_c(a2)
         bne.s    enr
         move.w   #4,(a2)
         cmp.w    #8,eoff_i(a2)
         bne      nboss
         move.w   #8,(A2)
nboss:   clr.w    eoff_c(a2)
en2:     cmp.w    #2,nume(a6)
         ble.s    gocrazy
         move.w   #2048,d0
         jsr      flib[random]
         cmp.w    #526,d0
         beq.s    gocrazy
         move.w   eoff_c(a2),d0
         lsr.w    #2,d0
         and.w    #28,d0
         lea      e1dirs(pc,d0.w),a0
         move.w   (a0)+,eoff_xv(a2)
         move.w   (a0)+,eoff_yv(a2)
         move.w   d7,d0
         add.w    d0,d0
         sub.w    eoff_c(a2),d0
         moveq    #2,d5
         and.w    high(a6),d0
         beq      shootu
enr:     rts
e1dirs:  dc.w     1,1,1,0,1,-1,0,-1,-1,-1,-1,0,-1,1,0,1
gocrazy: move.w   #6,(a2)
enrand:  move.w   #512,d0
         jsr      flib[random]
         ror.l    #5,d0
         tst.w    d0
         bne.s    \nocc
         rol.l    #5,d0
         and.w    #28,d0
         lea      e1dirs(pc),a0
         lea      0(a0,d0.w),a0
         move.w   (a0)+,eoff_xv(a2)
         move.w   (a0)+,eoff_yv(a2)
\nocc:   cmp.w    #16,eoff_x(a2)
         bgt.s    \1
         move.w   #2,eoff_xv(a2)
\1:      cmp.w    #20,eoff_y(a2)
         bgt.s    \2
         move.w   #2,eoff_yv(a2)
\2:      cmp.w    #95,eoff_y(a2)
         blt.s    \3
         move.w   #-2,eoff_yv(a2)
\3:      cmp.w    #165,eoff_x(a2)
         blt.s    \4
         move.w   #-2,eoff_xv(a2)
\4:      move.w   d7,d0
         sub.w    eoff_c(a2),d0
         and.w    low(a6),d0
         bne.s    enr3
         moveq    #2,d0
         jsr      flib[random]
         moveq    #2,d5
         tst.w    d0
         beq.s    shootu
enr3:    rts
shootu:  lea      tmp(a6),a1
         st       (a1)
         move.w   #1,eboff_d(a1)
         move.w   #5,eboff_w(a1)
         move.w   #5,eboff_h(a1)
         move.w   youx(a6),d0
         sub.w    eoff_x(a2),d0
         addq.w   #6,d0
         sub.w    d5,d0
         move.w   youy(a6),d1
         sub.w    eoff_y(a2),d1
         subq.w   #3,d1
         add.w    d0,d0
         add.w    d0,d0
         ext.l    d0
         divs     d1,d0
         cmp.w    #11,d0
         bge.s    xright
         cmp.w    #-11,d0
         ble.s    xleft
         move.w   #2,eboff_yv(a1)
         move.w   d0,eboff_xv(a1)
contsu:  move.w   eoff_x(a2),eboff_x(a1)
         add.w    d5,eboff_x(a1)
         move.w   eoff_y(a2),eboff_y(a1)
         addq.w   #8,eboff_y(a1)
         movem.l  d7/a2,-(sp)
         lea      ebuls(a6),a2
         bsr      put_struct
         movem.l  (sp)+,d7/a2
         rts
xright:  move.w   #1,eboff_yv(a1)
         move.w   #10,eboff_xv(a1)
         bra.s    contsu
xleft:   move.w   #1,eboff_yv(a1)
         move.w   #-10,eboff_xv(a1)
         bra.s    contsu
enboss:  move.w   eoff_c(a2),d0
         lsr.w    #2,d0
         and.w    #28,d0
         lea      e1dirs(pc),a0
         lea      0(a0,d0.w),a0
         move.w   (a0)+,eoff_xv(a2)
         move.w   (a0)+,eoff_yv(a2)
         cmp.w    #2,nume(a6)
         ble.s    bosscrazy
         move.w   d7,d0
         add.w    d0,d0
         sub.w    eoff_c(a2),d0
         and.w    #63,d0
         bne.s    rl17
         moveq    #0,d5
         bsr      shootu
         moveq    #12,d5
         bra      shootu
bosscrazy:
         moveq    #32,d0
         jsr      flib[random]
         tst.w    d0
         bne.s    nsn1
         moveq    #0,d5
         bsr      shootu
nsn1:    moveq    #32,d0
         jsr      flib[random]
         tst.w    d0
         bne.s    rl17
         moveq    #12,d5
         bsr      shootu
rl17:    rts

name:    dc.b     "Galaxian",0
cont:    dc.b     "Controls",0
stat:    dc.b     "Status",0

auths:   dc.b     168,15,"by Patrick Davidson",0
ems:     dc.b     170,23,"(ariwsi@juno.com)",0
smsg:    dc.b     161,98,"Shield level",0
pmsg:    dc.b     161,106,"Total score",0
lmsg:    dc.b     161,114,"Wave number",0
c1:      dc.b     168,46,"Cursor pad - Move",0
c2:      dc.b     168,53,"F1/F2/F3 - Shoot",0
c3:      dc.b     168,60,"Lock - Accelerate",0
c4:      dc.b     168,67,"APPS - Pause game",0
         dc.b     168,74,"ESC - Quick Exit",0
home:    dc.b     2,122,"HomePage - http://www.calweb.com/~kwdavids/patrick/ti92/",0
prog_name:
         dc.b     "1.2.008 / Patrick Davidson",0
game_win:
         dc.b     "YOU WIN!",0
game_over:
         dc.b     "GAME OVER - Press ESC",0
game_paused:
         dc.b     "GAME PAUSED",0
         reloc_open
         add_library       skittles
         add_library       hexlib
         add_library       flib
         reloc_close

         end
